#!bash
#输出文件名前缀
outfile_base="./long_wait_lock_info"

#连接信息
host=192.168.56.102
port=3306
user=root
passwd=transwarp

#检查次数
check_time=200

#每次检查时间间隔
check_interval=5

#锁等待时长阈值，超过该时间则被记录，单位：秒
min_wait_time=5

mysql_conn="mysql -u$user -p${passwd}"
#mysql_conn="mysql -h$host -u$user -p${passwd} -P$port"
#mysql_conn="mysql --socket=/mnt/disk5/kundb1/shard1/kundbdata/mysql.sock"


current_date=`date "+%Y%m%d_%H%M%S"`
outfile=${outfile_base}_${current_date}.log

echo "=======================begin check====================" >> $outfile
counter=0
while [ $counter -lt $check_time ]
do
echo `date +'%F %T.%3N'` >> $outfile

#查询锁等待状态
lock_wait_info=`$mysql_conn performance_schema -e "select REQUESTING_THREAD_ID,REQUESTING_ENGINE_TRANSACTION_ID,BLOCKING_THREAD_ID,BLOCKING_ENGINE_TRANSACTION_ID from data_lock_waits"`
echo "$lock_wait_info" | grep -v 'REQUESTING_THREAD_ID' | while read req_thread_id req_trx_id  blk_thread_id blk_trx_id;  do
    if [ -z "$req_thread_id" ]; then
        echo "no lock wait data"  >> $outfile
      continue
    fi

    #查询请求线程满足等待时间的当前SQL
    wait_info=`$mysql_conn performance_schema -e "select TIMER_WAIT/1000000000000 as TIMER_WAIT_SECONDS, SQL_TEXT as REQUESTING_WAIT_SQL  from events_statements_current where thread_id=$req_thread_id and END_EVENT_ID is NULL and TIMER_WAIT > ($min_wait_time*1000000000000)\G" | grep -v "row"`

    has_wait_info=`echo "$wait_info" | wc -l`
    if [ "$has_wait_info" -lt 2 ]; then
	    continue
    fi

    echo "REQUESTING_THREAD_ID: $req_thread_id"  >> $outfile
    echo "REQUESTING_ENGINE_TRANSACTION_ID:$req_trx_id" >> $outfile
    echo "BLOCKING_THREAD_ID: $blk_thread_id" >> $outfile
    echo "BLOCKING_ENGINE_TRANSACTION_ID:$blk_trx_id" >> $outfile
    echo "" >> $outfile

    echo $wait_info >> $outfile
    echo "" >> $outfile

    #查询锁的信息
    $mysql_conn performance_schema -e "select OBJECT_SCHEMA, OBJECT_NAME, INDEX_NAME, LOCK_DATA from data_locks where THREAD_ID=$blk_thread_id and ENGINE_TRANSACTION_ID=$blk_trx_id and LOCK_TYPE='RECORD' \G" | grep -v "row" >> $outfile

    echo "" >> $outfile

    #查询请求及阻塞的PROCESSLIST
    echo "REQUESTING_PROCESSLIST:" >> $outfile
    $mysql_conn performance_schema -e "select PROCESSLIST_ID,PROCESSLIST_USER,PROCESSLIST_HOST  from performance_schema.threads where THREAD_ID=${req_thread_id}\G" | grep -v "row" >> $outfile

    echo "" >> $outfile

    echo "BLOCK_PROCESSLIST:" >> $outfile
    $mysql_conn performance_schema -e "select PROCESSLIST_ID,PROCESSLIST_USER,PROCESSLIST_HOST  from performance_schema.threads where THREAD_ID=${blk_thread_id}\G" | grep -v "row" >> $outfile

    echo "" >> $outfile

    # 查询BLOCKING_THREAD_ID的当前SQL
   $mysql_conn performance_schema -e "SELECT SQL_TEXT as BLOCKING_THREAD_CURRENT_SQL, EVENT_ID, END_EVENT_ID, TIMER_WAIT/1000000000000 as TIMER_WAIT_SECONDS, LOCK_TIME/1000000000000 as LOCK_TIME_SECONDS FROM events_statements_current WHERE THREAD_ID=$blk_thread_id order by EVENT_ID\G" | grep -v "row" >> $outfile

    echo "" >> $outfile

    # 查询BLOCKING_THREAD_ID的历史SQL
    echo "BLOCKING THREAD HISTORY:" >> $outfile
    $mysql_conn performance_schema -e "SELECT SQL_TEXT, EVENT_ID, END_EVENT_ID, TIMER_WAIT/1000000000000 as TIMER_WAIT_SECONDS, LOCK_TIME/1000000000000 as LOCK_TIME_SECONDS FROM events_statements_history WHERE THREAD_ID=$blk_thread_id order by EVENT_ID\G" >> $outfile

    echo "" >> $outfile

    #查询REQUESTING_THREAD_ID的历史SQL
    echo "REQUESTING THREAD HISTORY:" >> $outfile
    $mysql_conn performance_schema -e "SELECT SQL_TEXT, EVENT_ID, END_EVENT_ID, TIMER_WAIT/1000000000000 as TIMER_WAIT_SECONDS, LOCK_TIME/1000000000000 as LOCK_TIME_SECONDS FROM events_statements_history WHERE THREAD_ID=$req_thread_id  order by EVENT_ID\G" >> $outfile

    echo "" >> $outfile
    echo "----------------------------------------------------------------------------------------------" >> $outfile
done

((counter++))
sleep $check_interval
done

echo `date +'%F %T.%3N'` >> $outfile
echo "========================end check======================" >> $outfile
